
'------------------------------------------------------------------------------
' This demo draws a path gradient brush from a star-shaped path with shadow !
' -> demo fixed for pbwin 9.03 and modified by frank brbach, 02.02.2010 :)
'------------------------------------------------------------------------------

#COMPILE EXE
#INCLUDE "win32api.inc"
#INCLUDE "gdiplus.inc"

SUB DrawGradient(BYVAL hDC&)

   LOCAL MiddleColorToOpaque AS DWORD
   LOCAL BlueFullTranslucent AS DWORD
   LOCAL RedFullTranslucent AS DWORD
   LOCAL YellowFullTranslucent AS DWORD
   LOCAL GreenFullTranslucent AS DWORD
   LOCAL CyanFullTranslucent AS DWORD
   LOCAL MagentaFullTranslucent AS DWORD
   LOCAL BlackFullTranslucent AS DWORD
   LOCAL WhiteFullTranslucent AS DWORD
   LOCAL hStatus AS LONG
   LOCAL pBrush AS DWORD
   LOCAL path1 AS DWORD
   LOCAL graphics1 AS DWORD

    REDIM pt(1 TO 10) AS POINTL
    pt(1).x = 175
    pt(1).y = 100
    pt(2).x = 200
    pt(2).y = 150
    pt(3).x = 250
    pt(3).y = 150
    pt(4).x = 212
    pt(4).y = 175
    pt(5).x = 250
    pt(5).y = 250
    pt(6).x = 175
    pt(6).y = 200
    pt(7).x = 100
    pt(7).y = 250
    pt(8).x = 137
    pt(8).y = 175
    pt(9).x = 100
    pt(9).y = 150
    pt(10).x = 150
    pt(10).y = 150

    REDIM pt1(1 TO 10) AS POINTL
    pt1(1).x = 75
    pt1(1).y = 0
    pt1(2).x = 100
    pt1(2).y = 50
    pt1(3).x = 150
    pt1(3).y = 50
    pt1(4).x = 112
    pt1(4).y = 75
    pt1(5).x = 150
    pt1(5).y = 150
    pt1(6).x = 75
    pt1(6).y = 100
    pt1(7).x = 0
    pt1(7).y = 150
    pt1(8).x = 37
    pt1(8).y = 75
    pt1(9).x = 0
    pt1(9).y = 50
    pt1(10).x = 50
    pt1(10).y = 50


    CALL GdipCreateFromHDC(hDC&, graphics&)
    CALL GdipCreateFromHDC(hDC&, graphics1)

  ' Create a GraphicsPath object
    CALL GdipCreatePath(%FillModeAlternate, path&)
    CALL GdipCreatePath(%FillModeAlternate, path1)

  ' Use the array of points to construct a path.
    CALL GdipAddPathLine2I(path&, pt(1), 10)
    CALL GdipAddPathLine2I(path1, pt1(1), 10)

  ' Use the path to construct a path gradient brush.
    CALL GdipCreatePathGradientFromPath(path&, brush&)
    CALL GdipCreatePathGradientFromPath(path1, pbrush)

    RedFullTranslucent = GDIP_ARGB_SetAlphaValue(%ARGB_RED,64)
    hStatus = GdipSetPathGradientCenterColor(pBrush, RedFullTranslucent)

    WhiteFullTranslucent = GDIP_ARGB_SetAlphaValue(%ARGB_WHITE, 64)
    hStatus = GdipSetPathGradientCenterColor(pBrush, WhiteFullTranslucent)

    GreenFullTranslucent = GDIP_ARGB_SetAlphaValue(%ARGB_GREEN, 64)
    hStatus = GdipSetPathGradientCenterColor(pBrush, GreenFullTranslucent)

    YellowFullTranslucent = GDIP_ARGB_SetAlphaValue(%ARGB_YELLOW, 64)
    hStatus = GdipSetPathGradientCenterColor(pBrush, YellowFullTranslucent)

    BlackFullTranslucent = GDIP_ARGB_SetAlphaValue(%ARGB_Black, 64)
    hStatus = GdipSetPathGradientCenterColor(pBrush, BlackFullTranslucent)

  ' Set the colors of the points in the array.
    Count& = 10
    REDIM Colors(1 TO Count&) AS LONG
    Colors(1)  = %ARGB_Red 'ColorARGB(255, 0, 0, 0)
    Colors(2)  = %ARGB_Yellow 'ColorARGB(255, 0, 255, 0)
    Colors(3)  = %ARGB_Blue 'ColorARGB(255, 0, 0, 255)
    Colors(4)  = %ARGB_White 'ColorARGB(255, 255, 255, 255)
    Colors(5)  = %ARGB_Black 'ColorARGB(255, 0, 0, 0)
    Colors(6)  = %ARGB_Red 'ColorARGB(255, 0, 255, 0)
    Colors(7)  = %ARGB_Blue 'ColorARGB(255, 0, 0, 255)
    Colors(8)  = %ARGB_White 'ColorARGB(255, 255, 255, 255)
    Colors(9)  = %ARGB_Black 'ColorARGB(255, 0, 0, 0)
    Colors(10) = %ARGB_Yellow 'ColorARGB(255, 0, 255, 0)
    CALL GdipSetPathGradientSurroundColorsWithCount(brush&, Colors(1), Count&)

  ' Fill the path with the path gradient brush.
    CALL GdipFillPath(graphics&, brush&, path&)
    CALL GdipFillPath(graphics&, pbrush, path1)

  ' Cleanup
    CALL GdipDeletePath(path&)
    CALL GdipDeletePath(path1)
    CALL GdipDeleteBrush(brush&)
    CALL GdipDeleteBrush(pbrush)
    CALL GdipDeleteGraphics(graphics&)
    CALL GdipDeleteGraphics(graphics1)

END SUB

'----------------------------------------------------------------------------------------------------------------
FUNCTION WndProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
'----------------------------------------------------------------------------------------------------------------
   LOCAL hDC AS DWORD
   LOCAL ps AS PAINTSTRUCT

   SELECT CASE wMsg

      CASE %WM_COMMAND
         SELECT CASE LOWRD(wParam)
            CASE %IDCANCEL
               IF HIWRD(wParam) = %BN_CLICKED THEN
                  SendMessage hWnd, %WM_CLOSE, 0, 0
                  FUNCTION = 0
                  EXIT FUNCTION
               END IF
         END SELECT

      CASE %WM_SYSCOMMAND
         ' Capture this message and send a WM_CLOSE message
         IF (wParam AND &HFFF0) = %SC_CLOSE THEN
            SendMessage hWnd, %WM_CLOSE, 0, 0
            EXIT FUNCTION
         END IF

      CASE %WM_PAINT
         hDC = BeginPaint(hWnd, ps)
         DrawGradient hDC
         EndPaint(hWnd, ps)

      CASE %WM_DESTROY
         PostQuitMessage 0
         EXIT FUNCTION

   END SELECT

   FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)

END FUNCTION


' =========================================================================================================================================
  FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG
' =========================================================================================================================================
   LOCAL hr AS LONG
   LOCAL hWndMain AS DWORD
   LOCAL hCtl AS DWORD
   LOCAL hFont AS DWORD
   LOCAL wcex AS WndClassEx
   LOCAL szClassName AS ASCIIZ * 80
   LOCAL rc AS RECT
   LOCAL szCaption AS ASCIIZ * 255
   LOCAL nLeft AS LONG
   LOCAL nTop AS LONG
   LOCAL nWidth AS LONG
   LOCAL nHeight AS LONG
   LOCAL token AS DWORD
   LOCAL hDlg AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput

   ' Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hr = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hr THEN
      MSGBOX "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   hFont = GetStockObject(%ANSI_VAR_FONT)

   ' Register the window class
   szClassName        = "MyClassName"
   wcex.cbSize        = SIZEOF(wcex)
   wcex.style         = %CS_HREDRAW OR %CS_VREDRAW
   wcex.lpfnWndProc   = CODEPTR(WndProc)
   wcex.cbClsExtra    = 0
   wcex.cbWndExtra    = 0
   wcex.hInstance     = hInstance
   wcex.hCursor       = LoadCursor (%NULL, BYVAL %IDC_ARROW)
   wcex.hbrBackground = GetStockObject(%WHITE_BRUSH)
   wcex.lpszMenuName  = %NULL
   wcex.lpszClassName = VARPTR(szClassName)
   wcex.hIcon         = LoadIcon (%NULL, BYVAL %IDI_APPLICATION) ' Sample, if resource icon: LoadIcon(hInst, "APPICON")
   wcex.hIconSm       = LoadIcon (%NULL, BYVAL %IDI_APPLICATION) ' Remember to set small icon too..
   RegisterClassEx wcex

   ' Window caption
   szCaption = "gdiplus example with path for a star with shadow1 :) "

   ' Retrieve the nSize of the working area
   SystemParametersInfo %SPI_GETWORKAREA, 0, BYVAL VARPTR(rc), 0

   ' Calculate the position and nSize of the window
   nWidth  = (((rc.nRight - rc.nLeft)) + 2) * 0.85   ' 55% of the client screen width
   nHeight = (((rc.nBottom - rc.nTop)) + 2) * 0.80   ' 50% of the client screen height
   nLeft   = ((rc.nRight - rc.nLeft) \ 2) - nWidth \ 2
   nTop    = ((rc.nBottom - rc.nTop) \ 2) - (nHeight \ 2)

   ' Create a window using the registered class
   hWndMain = CreateWindowEx(%WS_EX_CONTROLPARENT, _           ' extended style
                             szClassName, _                    ' window class name
                             szCaption, _                      ' window caption
                             %WS_OVERLAPPEDWINDOW OR _
                             %WS_CLIPCHILDREN, _               ' window style
                             nLeft, _                          ' initial x position
                             nTop, _                           ' initial y position
                             nWidth, _                         ' initial x nSize
                             nHeight, _                        ' initial y nSize
                             %NULL, _                          ' parent window handle
                             0, _                              ' window menu handle
                             hInstance, _                      ' program instance handle
                             BYVAL %NULL)                      ' creation parameters

   ' Show the window
   ShowWindow hWndMain, nCmdShow
   UpdateWindow hWndMain

   ' Message handler loop
   LOCAL Msg AS tagMsg
   WHILE GetMessage(Msg, %NULL, 0, 0)
      IF ISFALSE IsDialogMessage(hWndMain, Msg) THEN
         TranslateMessage Msg
         DispatchMessage Msg
      END IF
   WEND

   ' Shutdown GDI+
   GdiplusShutdown token

   FUNCTION = msg.wParam

END FUNCTION
